#ifndef KDK_HK_LUKS_H
#define KDK_HK_LUKS_H

#include <stdlib.h>
#include <string.h>
#include <unistd.h>


#define SECTOR_SIZE 512
#define MAX_CIPHER_LEN 32
#define DEFAULT_CIPHER(type) (DEFAULT_##type##_CIPHER "-" DEFAULT_##type##_MODE)
#ifdef __cplusplus
extern "C"
{
#endif
    int crypt_disk_tools_recovery_TPM_key_no_change();
    int crypt_disk_tools_seal_TPM_key_no_change();
    int crypt_disk_Km1_Update_hk_device(char *device, char *password, size_t passwortlen);
    /*
        通过密码打开加密设备
        若不输入密码和密码长度，则使用默认TPM密码，使用TPM密钥对应的返回值
        返回 -104：TPM密码失效
            -101：TPM自检失败
            -102：TPM密钥不存在
            -103：硬件环境存在问题
    */
    int crypt_disk_open_encrypted_hk_device(char *device, char *password, size_t passwortlen);
    int crypt_disk_encrypt_hk_device(char *device);
    int crypt_disk_open_can_with_hk_TPM(char *device);
    int crypt_get_device_info_from_log(char *device, char *serial_number, char *time_str);
    int crypt_set_device_info_to_log(char *device);
    int crypt_disk_is_encrypted(char *device);
    int crypt_tools_get_TPM_mode_seal_or_recovery();
    int crypt_disk_mount_ro_remount(char *device);
#ifdef __cplusplus
}
#endif
#endif